import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import Vue from 'vue';
import { Button, Dialog } from 'element-ui';
import { f as fixJsxImport } from '../../utils/fixJsxImport.js';
var modules_0806e81c = {
  "container": "index_module_container__ee851a5b",
  "footer": "index_module_footer__ee851a5b"
};
fixJsxImport(Dialog, Button);
var index = Vue.extend({
  name: "Dialog",
  props: {
    width: [String, Number],
    title: String,
    visible: {
      type: Boolean,
      "default": true
    },
    showClose: {
      type: Boolean,
      "default": true
    },

    /**
     * class name[s]
     */
    className: {
      type: [String, Array],
      "default": undefined
    },
    closeOnClickModal: {
      type: Boolean,
      "default": false
    },

    /**
     * 是否显示对话框底部，默认显示
     */
    withFooter: {
      type: Boolean,
      "default": true
    },
    confirmTxt: {
      type: String,
      "default": "确认"
    },
    cancelTxt: {
      type: String,
      "default": "取消"
    },
    "on-confirm": {
      type: Function,
      "default": null
    },
    "on-close": {
      type: Function,
      "default": null
    }
  },
  computed: {
    classNames: function classNames() {
      var classes = [modules_0806e81c.container];
      var className = this.className;

      if (typeof className === "string") {
        classes.push(className);
      } else if (Array.isArray(className)) {
        classes.push.apply(classes, _toConsumableArray(className));
      }

      return classes.join(" ");
    }
  },
  methods: {
    handleConfirm: function handleConfirm() {
      this.$emit("on-confirm");
    },
    handleCancel: function handleCancel() {
      this.$emit("on-close");
    }
  },
  render: function render() {
    var h = arguments[0];
    return h(Dialog, {
      "class": this.classNames,
      "props": {
        "visible": this.visible,
        "width": this.width,
        "title": this.title,
        "showClose": this.showClose,
        "closeOnClickModal": this.closeOnClickModal,
        "appendToBody": true
      },
      "on": {
        "close": this.handleCancel
      }
    }, [this.$slots["default"], this.withFooter ? h("div", {
      "class": modules_0806e81c.footer,
      "slot": "footer"
    }, [this.$slots.footer ? this.$slots.footer : h("div", [h(Button, {
      "props": {
        "type": "primary"
      },
      "on": {
        "click": this.handleConfirm
      }
    }, [this.confirmTxt]), h(Button, {
      "on": {
        "click": this.handleCancel
      }
    }, [this.cancelTxt])])]) : null]);
  }
});
var mixin = Vue.extend({
  data: function data() {
    return {
      dialogVisible: false
    };
  },
  methods: {
    showDialog: function showDialog() {
      this.dialogVisible = true;
    },
    closeDialog: function closeDialog() {
      this.dialogVisible = false;
    },
    toggleDialog: function toggleDialog() {
      this.dialogVisible = !this.dialogVisible;
    }
  }
});
export default index;
export { mixin };
