import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import Vue from 'vue';
import { Input, Select, DatePicker, FormItem, Col, Row, Form, Option } from 'element-ui';
import { f as fixJsxImport } from '../../utils/fixJsxImport.js';
var modules_0806e81c = {
  "container": "index_module_container__63b181a7",
  "dateBox": "index_module_dateBox__63b181a7",
  "date": "index_module_date__63b181a7"
}; // babel会自动优化代码，将ElOption改成Option
// 重新赋值保留ElOption

var ElOption = Option;
fixJsxImport(Form, Row, Col, FormItem, DatePicker, Select, ElOption, Input);

function defaultModel(items) {
  var model = {};

  if (!Array.isArray(items)) {
    return model;
  }

  items.forEach(function (item) {
    var dftVal = "";

    if (item.hasOwnProperty("default")) {
      dftVal = item["default"];

      if (typeof dftVal === "function") {
        dftVal = dftVal();
      }
    }

    model[item.prop] = dftVal;
  });
  return model;
}

function optionValue(option) {
  if (Array.isArray(option) && option.length === 2) {
    // 两个元素数组，如["N", "未过卡"]
    return option[0];
  } else if (Object.keys(option).length === 1) {
    // 只有一个key的对象{"N": "未过卡"}
    // 只能支持字符串类型的value？
    return Object.keys(option)[0];
  } else if ("value" in option) {
    // {value: "N", label: "未过卡"}
    return option.value;
  }

  return "";
}

function optionLabel(option) {
  if (Array.isArray(option) && option.length === 2) {
    return option[1];
  } else if (Object.keys(option).length === 1) {
    var key = Object.keys(option)[0];
    return option[key];
  } else if ("label" in option) {
    return option.label;
  }

  return "";
}

var index = Vue.extend({
  name: "Form",
  props: {
    labelPosition: {
      type: String,
      "default": "right"
    },
    labelWidth: {
      type: [String, Number],
      "default": "120px"
    },
    model: Object,
    items: Function,

    /**
     * 如果使用渲染函数需要手动监听`change`事件处理form model变化
     */
    change: {
      type: Function,
      "default": undefined
    }
  },
  methods: {
    resetFields: function resetFields() {
      return this.$refs.form.resetFields();
    },
    clearValidate: function clearValidate() {
      return this.$refs.form.clearValidate();
    },
    validate: function validate() {
      return this.$refs.form.validate();
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    return h("div", {
      "class": modules_0806e81c.container
    }, [h(Form, {
      "ref": "form",
      "props": _objectSpread({}, {
        model: this.model,
        labelPosition: this.labelPosition,
        labelWidth: this.labelWidth
      })
    }, [h(Row, [this.items().map(function (item) {
      var _this$$scopedSlots$it, _this$$scopedSlots, _item$options;

      return h(Col, {
        "key": item.prop,
        "props": {
          "span": item.span !== undefined ? item.span : 6 / 8
        }
      }, [item.slot ? (_this$$scopedSlots$it = (_this$$scopedSlots = _this.$scopedSlots)[item.slot]) === null || _this$$scopedSlots$it === void 0 ? void 0 : _this$$scopedSlots$it.call(_this$$scopedSlots, {
        item: item
      }) : h(FormItem, {
        "class": item.classes,
        "props": {
          "required": item.required,
          "label": item.label,
          "prop": item.prop,
          "rules": item.rules
        }
      }, [/^(daterange|date)$/.test(item.type) ? h(DatePicker, {
        "class": [modules_0806e81c.dateBox, modules_0806e81c[item.type] || ""],
        "props": {
          "value": _this.model[item.prop],
          "disabled": item.disabled,
          "type": item.type,
          "valueFormat": item.valueFormat || "yyyy-MM-dd",
          "format": item.format,
          "rangeSeparator": "-",
          "startPlaceholder": "开始日期",
          "endPlaceholder": "结束日期"
        },
        "on": {
          "input": function input(val) {
            _this.model[item.prop] = val;

            _this.$emit("change", _objectSpread({}, _this.model));
          }
        }
      }) : item.type === "select" ? h(Select, {
        "props": {
          "value": _this.model[item.prop],
          "disabled": item.disabled,
          "filterable": item.filterable,
          "remote": item.remote,
          "remoteMethod": item.remoteMethod,
          "loading": item.loading
        },
        "on": {
          "change": function change(val) {
            _this.model[item.prop] = val;

            _this.$emit("change", _objectSpread({}, _this.model));
          }
        }
      }, [(_item$options = item.options) === null || _item$options === void 0 ? void 0 : _item$options.map(function (option) {
        var value = optionValue(option);
        var label = optionLabel(option);
        return h(ElOption, {
          "key": label,
          "props": {
            "label": label,
            "value": value
          }
        });
      })]) : h(Input, {
        "props": {
          "value": _this.model[item.prop],
          "disabled": item.disabled
        },
        "on": {
          "input": function input(val) {
            var _item$input;

            _this.model[item.prop] = val;

            _this.$emit("change", _objectSpread({}, _this.model));

            (_item$input = item.input) === null || _item$input === void 0 ? void 0 : _item$input.call(item);
          },
          "blur": function blur() {
            var _item$blur;

            (_item$blur = item.blur) === null || _item$blur === void 0 ? void 0 : _item$blur.call(item);
          }
        }
      })])]);
    })])])]);
  }
});
export default index;
export { defaultModel, optionLabel, optionValue };
